fn round valor =
(
	temp = valor - (valor as integer)
	if (temp<0.5) then 
		valor = floor (valor)
	else
		valor = ceil (valor)
	valor = valor as integer
)

-------------------------------------------------------
-- VARIABLES
-------------------------------------------------------
num_objects=0	-- Num d'objectes totals
num_keys=0		-- Num de keys totals
max_x=#()		-- Maxim de cada objecte
max_y=#()
max_z=#()

key_x=#()		-- Keys de posici optimitzats
key_y=#()
key_z=#()

num_object=0	-- TEMP: Numero d'objecte al que estem
time_temp=0		-- TEMP: Temps


f=openfile "anim_3d.cpp" mode:"w"

format "#include \"../../stdafx.h\"\n" to: f

format "//////////////////////////////////////////////\n" to: f
format "// Arxiu generat amb el Script-Exporter del 3DStudioMax\n" to: f
format "// By Pere Felices Miln (Xphere)\n" to: f
format "//                  Zona Neutra Demogroup :: www.zonan.org\n" to: f
format "//////////////////////////////////////////////\n\n" to: f

-------------------------------------------------------
-- Total number of objects and position keys in the scene
for obj in $SPHERE* do
(
	if obj.pos.isAnimated then
	(
		num_objects=num_objects+1
		if obj.pos.isAnimated then
		(
			local i = numKeys obj.pos.controller
			i=i-1 -- El key 0 no conta
			num_keys=num_keys+i 
		)
	)
)

temporal=4+4*num_objects+num_keys*4+(num_objects*3)+(num_keys+num_objects)*3

format "// Total Memory: % bytes\n" temporal to: f
format "unsigned short int num_obj= %; \n" num_objects to: f
-------------------------------------------------------
-- Escrivim el nmero de keys q te cada objecte
format "\n// Numero de keys que te cada objecte (contant la key 0, que sempre hi s)" to: f
format "\nunsigned short int scene_keys[%]={" num_objects to: f
num_object=1
for obj in $SPHERE* do
(
	if obj.pos.isAnimated then
	(
		local i = numKeys obj.pos.controller
		i=i
		format "%" i to: f
		if num_object!=num_objects then
			format "," i to: f
		else
			format "};\n" i to: f
		num_object=num_object+1
	)
)

-------------------------------------------------------
-- Escrivim la posici de les keys q tenen els objectes
num_object=1 -- Resetejem el contador
format "\n// Posici de les keys que tenen els objectes (execpte la primera, que sempre hi s i sempre s la 0)" to: f
format "\nunsigned short int pos_keys[%]={" num_keys to: f
for obj in $SPHERE* do
(
	if obj.pos.isAnimated then
	(
		local i = numKeys obj.pos.controller
		for p = 1 to i do
		(
			local time = getKeyTime obj.pos.controller p
			time_temp = time as integer	-- time_temp l'uso per treure la lletra "f" q s'afegeix a la variable time
			time_temp = time_temp/160

			if (p!=1) then -- El primer key sempre sabem que s el 0 (amb aixo ens evitem posar el primer key)
				format "%" time_temp to: f
			
			if (num_object==num_objects and p==i) then -- En el cas de ser l'ultima key de l'ultim objecte tanquem claus
				format "};\n" to: f
			else
				if (p!=1) then
					format "," to: f

		)
	num_object=num_object+1
	)
)

cnt_key=1	-- Contador keys
cnt_obj=1	-- Contador objectes
-------------------------------------------------------
-- Llegim els keys, optimitzem i calculem els mxims
for obj in $SPHERE* do
(
	if obj.pos.isAnimated then
	(
		max_x[cnt_obj]=0			-- Init Max array values
		max_y[cnt_obj]=0			-- Init Max array values
		max_z[cnt_obj]=0			-- Init Max array values

		local i = numKeys obj.pos.controller

		-- Trobem els maxims de X, Y i Z de cada objecte
		for p = 1 to i do
		(
			current = getKey obj.pos.controller p
			if (max_x[cnt_obj] < current.value.x) then
				max_x[cnt_obj] = round (current.value.x)
			if (max_y[cnt_obj] < current.value.y) then
				max_y[cnt_obj] = round (current.value.y)
			if (max_z[cnt_obj] < current.value.z) then
				max_z[cnt_obj] = round (current.value.z)
		)

		-- Optimitzem les Keys
		for p = 1 to i do
		(
			current = getKey obj.pos.controller p

			-- Obtenim un valor float de 0 a 1 en funci de lo prxim que esta al valor maxim
			key_x[cnt_key] = (current.value.x / max_x[cnt_obj])
			key_y[cnt_key] = (current.value.y / max_y[cnt_obj])
			key_z[cnt_key] = (current.value.z / max_z[cnt_obj])

			if (key_x[cnt_key] > 1) then key_x[cnt_key]=1 -- Uns petits ajustos... :P
			if (key_y[cnt_key] > 1) then key_y[cnt_key]=1
			if (key_z[cnt_key] > 1) then key_z[cnt_key]=1
			
			-- Arrodonim

			key_x[cnt_key] = round (key_x[cnt_key]*255.0)
			key_y[cnt_key] = round (key_y[cnt_key]*255.0)
			key_z[cnt_key] = round (key_z[cnt_key]*255.0)

			cnt_key=cnt_key+1
		)
		cnt_obj=cnt_obj+1
	)
)


-------------------------------------------------------
-- Escrivim el valor dels mxims (3 valors per cada objecte (3 pq hi ha la X, Y i Z)
cnt=1
format "\n// Mxims de cada objecte" to: f
format "\nunsigned char maxims[%]={\n" (num_objects*3) to: f
for p = 1 to num_objects do
(
	format "%,%,%" max_x[p] max_z[p] max_y[p] to: f -- Invertim Y i Z (OpenGL compatible)
	
	if (p!=num_objects) then
		format "," to: f
	else
		format "};\n" to: f

	cnt=cnt+1
	if (cnt==30) then
	(
		format "\n" to: f
		cnt=0
	)
)

-------------------------------------------------------
-- Escrivim el valor dels keys q tenen tots els objectes
format "\n// Keys de tots els objectes (la key 0 tamb hi s inclosa)" to: f
format "\nunsigned char keys[%]={\n" ((num_keys+num_objects)*3) to: f
cnt=0
cnt_obj=1
cnt_key=1
for obj in $SPHERE* do
(
	if obj.pos.isAnimated then
	(
		local i = numKeys obj.pos.controller
		for p = 1 to i do
		(
			format "%,%,%" key_x[cnt_key] key_z[cnt_key] key_y[cnt_key] to: f -- Invertim Y i Z (OpenGL compatible)
			if (p==i and cnt_obj==num_objects) then
				format "};\n" to: f
			else
				format "," to: f
			
			cnt_key=cnt_key+1
			cnt=cnt+1
			if (cnt==10) then
			(
				format "\n" to: f
				cnt=0
			)
		)
	cnt_obj=cnt_obj+1
	)
)


format "\n/*" to: f
------------------------------------------------------------------------------
for obj in $SPHERE* do
(
	format "\nName: %\n" obj.name to: f
	if obj.pos.isAnimated then
	(
		local i = numKeys obj.pos.controller
	
		format "PosTracks: %\n" i to: f
		for p = 1 to i do
		(
			local time = getKeyTime obj.pos.controller p
			current = getKey obj.pos.controller p
			format "  [%] - X:% Y:% Z:%\n" time current.value.x current.value.y current.value.z to: f
		)
	)
)
format "\n*/" to: f

close f
